% **************************************************************************** %
% Author: Lambert Theisen
% => lambert.theisen@rwth-aachen.de
% => lambert.theisen@gmail.com
% Created: January 2019
% **************************************************************************** %



% **************************************************************************** %
% MATHEMATICS
% **************************************************************************** %

  % -------------------------------------------------------------------------- %
  % GENERAL MATH
  % -------------------------------------------------------------------------- %
    \usepackage{amsmath}
  % -------------------------------------------------------------------------- %

  % -------------------------------------------------------------------------- %
  % MATH SYMBOLS
  % -------------------------------------------------------------------------- %
    \usepackage{amssymb}
  % -------------------------------------------------------------------------- %

  % -------------------------------------------------------------------------- %
  % MATH FONTS
  % => Natural numbers with mathbb{N}
  % -------------------------------------------------------------------------- %
    \usepackage{amsfonts}
  % -------------------------------------------------------------------------- %

  % -------------------------------------------------------------------------- %
  % MATH THEOREMS, DEFINITIONS, PROBLEMS, ...
  % =>
  % -------------------------------------------------------------------------- %
    \usepackage{amsthm}
  % -------------------------------------------------------------------------- %

  % -------------------------------------------------------------------------- %
  % NUMCASES AND SUBNUMCASES
  % => To have equations numbered with (1.1a)
  % -------------------------------------------------------------------------- %
    \usepackage[subnum]{cases}
  % -------------------------------------------------------------------------- %

  % -------------------------------------------------------------------------- %
  % OVERLOAD ENVS (ALIGN,..) TO TAKE ARGUMENT TO LEFT
  % => E.g."\begin{alignat}{2}%[left={\empheqlbrace}]" to simulate cases
  % -------------------------------------------------------------------------- %
    \usepackage[overload]{empheq}
  % -------------------------------------------------------------------------- %

  % -------------------------------------------------------------------------- %
  % PAIRED OPERATIONS
  % -------------------------------------------------------------------------- %
    \usepackage{mathtools} % For DeclarePairedDelimiter

    \DeclarePairedDelimiter{\abs}{\lvert}{\rvert}
    \DeclarePairedDelimiter{\norm}{\lVert}{\rVert}
    \DeclarePairedDelimiter{\ceil}{\lceil}{\rceil}
    \DeclarePairedDelimiter{\scp}{\langle}{\rangle}

    \newcommand{\@supnormstar}[1]{\norm*{#1}_\infty}
    \newcommand{\@supnormnostar}[2][]{\norm[#1]{#2}_\infty}
    \newcommand{\supnorm}{\@ifstar\@supnormstar\@supnormnostar}
    \newcommand{\@eunormstar}[1]{\norm*{#1}_2}
    \newcommand{\@eunormnostar}[2][]{\norm[#1]{#2}_2}
    \newcommand{\eunorm}{\@ifstar\@eunormstar\@eunormnostar}
  % -------------------------------------------------------------------------- %

  % -------------------------------------------------------------------------- %
  % OPERATORS
  % -------------------------------------------------------------------------- %
    \usepackage{amsmath,amsopn}
    \DeclareMathOperator{\avg}{avg}
    \DeclareMathOperator{\sign}{sign}
    \DeclareMathOperator{\trace}{trace}
    \DeclareMathOperator{\diag}{diag}

    % textual
    \DeclareMathOperator{\diver}{div}
    \DeclareMathOperator{\grad}{grad}
    \DeclareMathOperator{\rot}{rot}
    \DeclareMathOperator{\curl}{curl}

    % vectorial
    \DeclareMathOperator{\divV}{\vek{\nabla} \cdot}
    \DeclareMathOperator{\gradV}{\vek{\nabla}}
    \DeclareMathOperator{\rotV}{TODO}
    \DeclareMathOperator{\curlV}{TODO}

    % statistics:
    \DeclareMathOperator{\var}{var}
    \DeclareMathOperator{\cov}{cov}

    \DeclareMathOperator{\Tr}{Tr}
  % -------------------------------------------------------------------------- %

  % -------------------------------------------------------------------------- %
  % DIMENSIONLESS NUMBERS
  % => https://tex.stackexchange.com/questions/129397/ + ...
  % how-to-properly-typeset-multiletter-quantities-e-g-re-or-nu-reynolds-nusselt
  % -------------------------------------------------------------------------- %
    \usepackage{amsmath}

    \newcommand{\Arch}{\operatorname{Ar}}
    \newcommand{\Biot}{\operatorname{Bi}}
    \newcommand{\Cauc}{\operatorname{Ca}}
    \newcommand{\Damk}{\operatorname{Da}}
    \newcommand{\Eule}{\operatorname{Eu}}
    \newcommand{\Four}{\operatorname{Fo}}
    \newcommand{\Frou}{\operatorname{Fr}}
    \newcommand{\Gras}{\operatorname{Gr}}
    \newcommand{\Karl}{\operatorname{Ka}}
    \newcommand{\Knud}{\operatorname{Kn}}
    \newcommand{\Lewi}{\operatorname{Le}}
    \newcommand{\Mach}{\operatorname{Ma}}
    \newcommand{\Nuss}{\operatorname{Nu}}
    \newcommand{\Pecl}{\operatorname{Pe}}
    \newcommand{\Pran}{\operatorname{Pr}}
    \newcommand{\Rayl}{\operatorname{Ra}}
    \newcommand{\Reyn}{\operatorname{Re}}
    \newcommand{\Schm}{\operatorname{Sc}}
    \newcommand{\Sher}{\operatorname{Sh}}
    \newcommand{\Stro}{\operatorname{Sr}}
    \newcommand{\Webe}{\operatorname{We}}
    \newcommand{\Cour}{\operatorname{Co}}

    % \newcommand{\Arch}{\operatorname{\mathit{A\kern-.06em r}}}
    % \newcommand{\Biot}{\operatorname{\mathit{B\kern-.06em i}}}
    % \newcommand{\Cauc}{\operatorname{\mathit{C\kern-.07em a}}}
    % \newcommand{\Damk}{\operatorname{\mathit{D\kern-.06em a}}}
    % \newcommand{\Eule}{\operatorname{\mathit{E\kern-.03em u}}}
    % \newcommand{\Four}{\operatorname{\mathit{F\kern-.10em o}}}
    % \newcommand{\Frou}{\operatorname{\mathit{F\kern-.07em r}}}
    % \newcommand{\Gras}{\operatorname{\mathit{G\kern-.05em r}}}
    % \newcommand{\Karl}{\operatorname{\mathit{K\kern-.11em a}}}
    % \newcommand{\Knud}{\operatorname{\mathit{K\kern-.11em n}}}
    % \newcommand{\Lewi}{\operatorname{\mathit{L\kern-.05em e}}}
    % \newcommand{\Mach}{\operatorname{\mathit{M\kern-.10em a}}}
    % \newcommand{\Nuss}{\operatorname{\mathit{N\kern-.09em u}}}
    % \newcommand{\Pecl}{\operatorname{\mathit{P\kern-.08em e}}}
    % \newcommand{\Pran}{\operatorname{\mathit{P\kern-.03em r}}}
    % \newcommand{\Rayl}{\operatorname{\mathit{R\kern-.04em a}}}
    % \newcommand{\Reyn}{\operatorname{\mathit{R\kern-.04em e}}}
    % \newcommand{\Schm}{\operatorname{\mathit{S\kern-.07em c}}}
    % \newcommand{\Sher}{\operatorname{\mathit{S\kern-.07em h}}}
    % \newcommand{\Stro}{\operatorname{\mathit{S\kern-.07em r}}}
    % \newcommand{\Webe}{\operatorname{\mathit{W\kern-.14em e}}}
    % \newcommand{\Cour}{\operatorname{\mathit{C\kern-.14em o}}}

    % obsolete
    \DeclareMathOperator{\pen}{\textit{Pe}}
    % \newcommand\Pran{\mathit{Pr}} % Prandtl number, cf TeX's \Pr product.
    % \newcommand\Co{\mathit{Co}}
  % -------------------------------------------------------------------------- %

  % -------------------------------------------------------------------------- %
  % ABBREVIATIONS
  % -------------------------------------------------------------------------- %
    \newcommand{\fa}{\ensuremath{\forall}}
    \newcommand{\fol}{\ensuremath{\Rightarrow}}
    \newcommand{\eq}{\ensuremath{\Leftrightarrow}}
    \newcommand{\is}{\ensuremath{\widehat{=}}}
    \newcommand{\mbeq}{\ensuremath{\overset{!}{=}}}
    \newcommand{\mbl}{\ensuremath{\overset{!}{<}}}
    \newcommand{\mbg}{\ensuremath{\overset{!}{>}}}
    \newcommand{\ip}{\ensuremath{\boldsymbol{\cdot}}}

    % Derivative (physic pack errors)
    \newcommand{\dd}{\mathop{}\text{d}} % infinitissemal symbol
    \newcommand{\DD}{\mathop{}\text{D}} % infinitissemal symbol
    \newcommand{\pdv}[2]{\frac{\partial#1}{\partial#2}}
    \newcommand{\ppdv}[2]{\frac{\partial^2#1}{\partial#2^2}}
    \newcommand{\tdv}[2]{\frac{\dd#1}{\dd#2}}
    \newcommand{\ttdv}[2]{\frac{\dd^2#1}{\dd#2^2}}
    \newcommand{\mdv}[2]{\frac{\DD#1}{\DD#2}}
    \newcommand{\mmdv}[2]{\frac{\DD^2#1}{\DD#2^2}}
    \newcommand{\pd}[1]{\frac{\partial}{\partial#1}}
    \newcommand{\ppd}[1]{\frac{\partial^2}{\partial#1^2}}
    \newcommand{\td}[1]{\frac{\dd}{\dd#1}}
    \newcommand{\ttd}[1]{\frac{\dd^2}{\dd#1^2}}
    \newcommand{\md}[1]{\frac{\DD}{\DD#1}}
    \newcommand{\mmd}[1]{\frac{\DD^2}{\DD#1^2}}
    \newcommand{\timesSmall}{{\mkern-2mu\times\mkern-2mu}} % less space around X
    \newcommand{\definedAs}{\ensuremath{\coloneqq}}
  % -------------------------------------------------------------------------- %

  % -------------------------------------------------------------------------- %
  % MATH TYPESET
  % -------------------------------------------------------------------------- %
    \usepackage{bm} % \bm for bold math text style used in vectors and matrices
    \newcommand{\ten}[1]{\ensuremath{\bm{\mathbf{#1}}}}
    % \newcommand{\ten}[1]{\ensuremath{\vek{#1}}} % dont use normal tensor def
    % \newcommand{\mat}[1]{\ensuremath{\bm{\mathsf #1}}}
    \newcommand{\mat}[1]{\ensuremath{\ten{#1}}}
    \newcommand{\vek}[1]{\ensuremath{\bm{#1}}}
    \newcommand{\con}[1]{\ensuremath{\mathrm{#1}}}

    \newcommand{\te}[1]{\ensuremath{\underline{#1}}}
    \newcommand{\tee}[1]{\ensuremath{\underline{\te{#1}}}}
    \newcommand{\teee}[1]{\ensuremath{\underline{\tee{#1}}}}
    \newcommand{\teeee}[1]{\ensuremath{\underline{\teee{#1}}}}

    % TODO: Think about this if vector should be italic or not
    % \DeclareMathAlphabet{\mathsfit}{\encodingdefault}{\sfdefault}{m}{sl}
    % \SetMathAlphabet{\mathsfit}{bold}{\encodingdefault}{\sfdefault}{bx}{sl}
    % \newcommand{\tens}[1]{\bm{\mathsfit{#1}}}

    % \usepackage{isomath}
    % \renewcommand{\vec}{\vectorsym}
    % \newcommand{\tens}{\tensorsym}
    % % \newcommand{\mat}{\matrixsym}
    % \newcommand{\four}[1]{\underline{\vec {#1}}}

    % Greek symbols:
    % => For uppercase greek symbols, they dont have upright version normally
      \usepackage{upgreek}
      % \renewcommand{\pi}{\uppi} % pi is constant and therefore upright!
      % \renewcommand{\sigma}{\upsigma} % SIGMA NOT A CONSTANT!
      \newcommand{\phibar}{\bar{\phi}}
      \newcommand{\phiprime}{\phi^\prime}

    % Nomenclature:
    % => To have constants after vectors, dirty stylezz rockzz
      \newcommand{\vvsigma}{\upsigma}
      \newcommand{\vvcon}[1]{\con{#1}}
  % -------------------------------------------------------------------------- %

  % -------------------------------------------------------------------------- %
  % SMALL MATRICES (FOR NOTES)
  % -------------------------------------------------------------------------- %
    \newcommand{\bmat}[1]{ % less space in matrix
      \ensuremath{
        \begingroup % keep the change local
        \setlength\arraycolsep{2pt}
        \begin{bmatrix}
          #1
        \end{bmatrix}
        \endgroup
      }
    }
  % -------------------------------------------------------------------------- %

  % -------------------------------------------------------------------------- %
  % Bra-Ket Notation
  % -------------------------------------------------------------------------- %
  \DeclarePairedDelimiter\bra{\langle}{\rvert}
  \DeclarePairedDelimiter\ket{\lvert}{\rangle}
  \DeclarePairedDelimiterX\braket[2]{\langle}{\rangle}{#1 \delimsize\vert #2}

  % -------------------------------------------------------------------------- %
  % Argmax Argmin
  % -------------------------------------------------------------------------- %
  \DeclareMathOperator*{\argmax}{arg\,max}
  \DeclareMathOperator*{\argmin}{arg\,min}

% **************************************************************************** %